--
-- file generated by VGI
-- at Fri Mar 21 23:26:49 GMT+5 1997
--


library IEEE;
   use IEEE.std_logic_1164.all;



entity mealy is
	port( 
		SEL:	out	std_logic;
		ACTIVE:	out	std_logic;
		CLK:	in	std_logic;
		RST_N:	in	std_logic;
		CS_N:	in	std_logic;
		ADS_N:	in	std_logic;
		READY_N:	out	std_logic;
		WR_N:	in	std_logic
	    ); 
end mealy;


architecture fsm of mealy is




-- vgi_off (User defined signals go here)
-- vgi_on



  type m1_type is (IDLE, WAIT1, WR_FIN, RD_FIN);

  signal m1_state: m1_type;
  signal next_m1_state: m1_type;



begin


-- connecting internal signals to their entity ports






--
-- FSM: 
-- m1
--


-- state register
-----------------

m1_reg: process( CLK, RST)


begin

   if  RST = '0' then

      m1_state <= IDLE;

   elsif  CLK'event and CLK ='1' then

      m1_state <= next_m1_state;

   end if;

end process;



-- transition/output process
----------------------------

m1_trans: process(CLK, RST_N, CS_N, ADS_N, WR_N, m1_state)


begin

	                                    
	SEL <= '0';


      case m1_state is

         when IDLE =>

		if ADS_N =  '0' then
		   ACTIVE <= '1';
		   READY_N <= '1';
		   SEL <= '1';
		   next_m1_state <= WAIT1;
		end if;
		if ADS_N =  '1' then
		   ACTIVE <= '0';
		   READY_N <= '1';
		   next_m1_state <= IDLE;
		end if;

         when WAIT1 =>

		if WR_N =  '0' then
		   if CS_N =  '0' then
		      ACTIVE <= '1';
		      READY_N <= '0';
		      next_m1_state <= RD_FIN;
		   end if;
		   if CS_N =  '1' then
		      ACTIVE <= '1';
		      READY_N <= '0';
		      next_m1_state <= WAIT1;
		   end if;
		end if;
		if WR_N =  '1' then
		end if;

         when WR_FIN =>

		ACTIVE <= '0';
		READY_N <= '0';
		next_m1_state <= IDLE;

         when RD_FIN =>

		ACTIVE <= '0';
		READY_N <= '0';
		next_m1_state <= IDLE;

      end case;

end process;


-- vgi_off (User defined code goes here)
-- vgi_on

end fsm;
